## ros-lunar-behaviortree-cpp-v3 3.0.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12) # version on Ubuntu Trusty
project(behaviortree_cpp_v3)

if(NOT CMAKE_VERSION VERSION_LESS 3.1)
    set(CMAKE_CXX_STANDARD 11)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
endif()

if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_DEBUG_POSTFIX d)


set(CMAKE_CONFIG_PATH ${CMAKE_MODULE_PATH}  "${CMAKE_CURRENT_LIST_DIR}/cmake")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CONFIG_PATH}")

option(BUILD_EXAMPLES   "Build tutorials and examples" ON)
option(BUILD_UNIT_TESTS "Build the unit tests" ON)
option(BUILD_TOOLS "Build commandline tools" ON)

#############################################################
# Find packages
find_package(Threads REQUIRED)
find_package(ZMQ)

list(APPEND BEHAVIOR_TREE_EXTERNAL_LIBRARIES
    ${CMAKE_THREAD_LIBS_INIT}
    ${CMAKE_DL_LIBS} )

if( ZMQ_FOUND )
    message(STATUS "ZeroMQ found.")
    add_definitions( -DZMQ_FOUND )
    list(APPEND BT_SOURCE src/loggers/bt_zmq_publisher.cpp)
    list(APPEND BEHAVIOR_TREE_EXTERNAL_LIBRARIES zmq)
else()
    message(WARNING "ZeroMQ NOT found. Skipping the build of [PublisherZMQ] and [bt_recorder].")
endif()

set(BEHAVIOR_TREE_LIBRARY ${PROJECT_NAME})


# Update the policy setting to avoid an error when loading the ament_cmake package
# at the current cmake version level
if(POLICY CMP0057)
    cmake_policy(SET CMP0057 NEW)
endif()

find_package(ament_cmake QUIET)

if ( ament_cmake_FOUND )
    find_package(ament_cmake_gtest REQUIRED)

    # Not adding -DUSING_ROS since xml_parsing.cpp hasn't been ported to ROS2

    message(STATUS "------------------------------------------")
    message(STATUS "BehaviourTree is being built using AMENT.")
    message(STATUS "------------------------------------------")

    set(BUILD_TOOL_INCLUDE_DIRS ${ament_INCLUDE_DIRS})

elseif( CATKIN_DEVEL_PREFIX OR CATKIN_BUILD_BINARY_PACKAGE)

    set(catkin_FOUND 1)
    add_definitions( -DUSING_ROS )
    find_package(catkin REQUIRED COMPONENTS roslib)
    find_package(GTest)

    message(STATUS "------------------------------------------")
    message(STATUS "BehaviourTree is being built using CATKIN.")
    message(STATUS "------------------------------------------")

    catkin_package(
        INCLUDE_DIRS include # do not include "3rdparty" here
        LIBRARIES ${BEHAVIOR_TREE_LIBRARY}
        CATKIN_DEPENDS roslib
        )

    list(APPEND BEHAVIOR_TREE_EXTERNAL_LIBRARIES ${catkin_LIBRARIES})
    set(BUILD_TOOL_INCLUDE_DIRS ${catkin_INCLUDE_DIRS})

    find_package(backward_ros QUIET)
    if (backward_ros_FOUND)
        message(STATUS "backward_ros found, using it.")
        list(APPEND BEHAVIOR_TREE_EXTERNAL_LIBRARIES ${catkin_LIBRARIES} ${backward_ros_LIBRARIES})
    endif()

else()
    find_package(GTest)

    if(NOT GTEST_FOUND)
        message(WARNING " GTest missing!")
    endif(NOT GTEST_FOUND)

    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

endif()
if(NOT MSVC)
    list(APPEND BEHAVIOR_TREE_EXTERNAL_LIBRARIES "dw")
endif()

#############################################################
# LIBRARY

list(APPEND BT_SOURCE
    src/action_node.cpp
    src/basic_types.cpp
    src/behavior_tree.cpp
    src/blackboard.cpp
    src/bt_factory.cpp
    src/decorator_node.cpp
    src/condition_node.cpp
    src/control_node.cpp
    src/shared_library.cpp
    src/tree_node.cpp
    src/xml_parsing.cpp

    src/decorators/inverter_node.cpp
    src/decorators/repeat_node.cpp
    src/decorators/retry_node.cpp
    src/decorators/subtree_node.cpp
    src/decorators/timeout_node.cpp

    src/controls/fallback_node.cpp
    src/controls/parallel_node.cpp
    src/controls/reactive_sequence.cpp
    src/controls/reactive_fallback.cpp
    src/controls/sequence_node.cpp
    src/controls/sequence_star_node.cpp

    src/loggers/bt_cout_logger.cpp
    src/loggers/bt_file_logger.cpp
    src/loggers/bt_minitrace_logger.cpp
    src/private/tinyxml2.cpp

    3rdparty/minitrace/minitrace.cpp
    )

if (NOT backward_ros_FOUND)
    list(APPEND SRC_3rd_PARTY
        3rdparty/backward-cpp/backward.cpp)
endif()

######################################################
if (UNIX)
    list(APPEND BT_SOURCE src/shared_library_UNIX.cpp )
    add_library(${BEHAVIOR_TREE_LIBRARY} SHARED ${BT_SOURCE} )
endif()

if (WIN32)
    list(APPEND BT_SOURCE src/shared_library_WIN.cpp )
    add_library(${BEHAVIOR_TREE_LIBRARY} STATIC ${BT_SOURCE} )
endif()


target_link_libraries(${BEHAVIOR_TREE_LIBRARY} PUBLIC
    ${BEHAVIOR_TREE_EXTERNAL_LIBRARIES})

target_compile_definitions(${BEHAVIOR_TREE_LIBRARY} PRIVATE $<$<CONFIG:Debug>:TINYXML2_DEBUG>)


target_include_directories(${BEHAVIOR_TREE_LIBRARY} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty>
    $<INSTALL_INTERFACE:3rdparty>
    ${BUILD_TOOL_INCLUDE_DIRS})

if( ZMQ_FOUND )
    target_compile_definitions(${BEHAVIOR_TREE_LIBRARY} PUBLIC ZMQ_FOUND)
endif()

if(MSVC)
    target_compile_options(${BEHAVIOR_TREE_LIBRARY} PRIVATE /W4 /WX)
else()
    target_compile_options(${BEHAVIOR_TREE_LIBRARY} PRIVATE
        -Wall -Wextra -Werror=return-type -g)
endif()

######################################################
# Test
add_subdirectory(tests)

######################################################
# INSTALL
if(ament_cmake_FOUND)
    set( BEHAVIOR_TREE_LIB_DESTINATION   lib )
    set( BEHAVIOR_TREE_INC_DESTINATION   include )
    set( BEHAVIOR_TREE_BIN_DESTINATION   bin )

    ament_export_include_directories(include)
    ament_export_libraries(${BEHAVIOR_TREE_LIBRARY})
    ament_package()
elseif(catkin_FOUND)
    set( BEHAVIOR_TREE_LIB_DESTINATION   ${CATKIN_PACKAGE_LIB_DESTINATION} )
    set( BEHAVIOR_TREE_INC_DESTINATION   ${CATKIN_GLOBAL_INCLUDE_DESTINATION} )
    set( BEHAVIOR_TREE_BIN_DESTINATION   ${CATKIN_PACKAGE_BIN_DESTINATION} )
else()
    set( BEHAVIOR_TREE_LIB_DESTINATION   lib )
    set( BEHAVIOR_TREE_INC_DESTINATION   include )
    set( BEHAVIOR_TREE_BIN_DESTINATION   bin )
endif()

set(PROJECT_NAMESPACE BehaviorTree)
set(PROJECT_CONFIG ${PROJECT_NAMESPACE}Config)

INSTALL(TARGETS ${BEHAVIOR_TREE_LIBRARY}
    EXPORT ${PROJECT_CONFIG}
    ARCHIVE DESTINATION ${BEHAVIOR_TREE_LIB_DESTINATION}
    LIBRARY DESTINATION ${BEHAVIOR_TREE_LIB_DESTINATION}
    )

INSTALL( DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/
    DESTINATION ${BEHAVIOR_TREE_INC_DESTINATION}
    FILES_MATCHING PATTERN "*.h*")

install(EXPORT ${PROJECT_CONFIG}
    DESTINATION "${BEHAVIOR_TREE_LIB_DESTINATION}/${PROJECT_NAMESPACE}/cmake"
    NAMESPACE ${PROJECT_NAMESPACE}::)

export(TARGETS ${PROJECT_NAME}
    NAMESPACE ${PROJECT_NAMESPACE}::
    FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_CONFIG}.cmake")

######################################################
# EXAMPLES and TOOLS
if(BUILD_TOOLS)
    add_subdirectory(tools)
endif()

if( BUILD_EXAMPLES )
    add_subdirectory(sample_nodes)
    add_subdirectory(examples)
endif()

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

include_directories( ../sample_nodes )


# The plugin libdummy_nodes.so can be linked statically or
# loaded dynamically at run-time.
add_executable(t01_first_tree_static  t01_build_your_first_tree.cpp )
target_compile_definitions(t01_first_tree_static PRIVATE "MANUAL_STATIC_LINKING")
target_link_libraries(t01_first_tree_static ${BEHAVIOR_TREE_LIBRARY}   dummy_nodes )

add_executable(t01_first_tree_dynamic  t01_build_your_first_tree.cpp )
target_link_libraries(t01_first_tree_dynamic ${BEHAVIOR_TREE_LIBRARY}  )


add_executable(t02_basic_ports  t02_basic_ports.cpp )
target_link_libraries(t02_basic_ports ${BEHAVIOR_TREE_LIBRARY} dummy_nodes )

add_executable(t03_generic_ports        t03_generic_ports.cpp )
target_link_libraries(t03_generic_ports ${BEHAVIOR_TREE_LIBRARY}  movebase_node dummy_nodes  )

add_executable(t04_reactive_sequence         t04_reactive_sequence.cpp )
target_link_libraries(t04_reactive_sequence  ${BEHAVIOR_TREE_LIBRARY} movebase_node dummy_nodes  )

add_executable(t05_crossdoor         t05_crossdoor.cpp )
target_link_libraries(t05_crossdoor   ${BEHAVIOR_TREE_LIBRARY} crossdoor_nodes )

add_executable(t06_subtree_port_remapping  t06_subtree_port_remapping.cpp )
target_link_libraries(t06_subtree_port_remapping ${BEHAVIOR_TREE_LIBRARY}   dummy_nodes movebase_node )

add_executable(t07_wrap_legacy         t07_wrap_legacy.cpp )
target_link_libraries(t07_wrap_legacy   ${BEHAVIOR_TREE_LIBRARY} )

add_executable(t08_additional_node_args   t08_additional_node_args.cpp )
target_link_libraries(t08_additional_node_args   ${BEHAVIOR_TREE_LIBRARY} )

add_executable(t09_async_actions_coroutines  t09_async_actions_coroutines.cpp )
target_link_libraries(t09_async_actions_coroutines ${BEHAVIOR_TREE_LIBRARY} )

add_executable(t10_include_trees  t10_include_trees.cpp )
target_link_libraries(t10_include_trees  ${BEHAVIOR_TREE_LIBRARY} dummy_nodes )

=== sample_nodes/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

include_directories( ../include )

# compile as static libraries

add_library(crossdoor_nodes STATIC crossdoor_nodes.cpp )
target_link_libraries(crossdoor_nodes PRIVATE ${BEHAVIOR_TREE_LIBRARY})

add_library(dummy_nodes     STATIC dummy_nodes.cpp )
target_link_libraries(dummy_nodes PRIVATE ${BEHAVIOR_TREE_LIBRARY})

add_library(movebase_node   STATIC movebase_node.cpp )
target_link_libraries(movebase_node PRIVATE ${BEHAVIOR_TREE_LIBRARY})

# to create a plugin, compile them in this way instead

add_library(crossdoor_nodes_dyn SHARED crossdoor_nodes.cpp )
target_link_libraries(crossdoor_nodes_dyn PRIVATE ${BEHAVIOR_TREE_LIBRARY})
target_compile_definitions(crossdoor_nodes_dyn PRIVATE  BT_PLUGIN_EXPORT )

add_library(dummy_nodes_dyn     SHARED dummy_nodes.cpp )
target_link_libraries(dummy_nodes_dyn PRIVATE ${BEHAVIOR_TREE_LIBRARY})
target_compile_definitions(dummy_nodes_dyn  PRIVATE BT_PLUGIN_EXPORT)

add_library(movebase_node_dyn   SHARED movebase_node.cpp )
target_link_libraries(movebase_node_dyn PRIVATE ${BEHAVIOR_TREE_LIBRARY})
target_compile_definitions(movebase_node_dyn PRIVATE  BT_PLUGIN_EXPORT )

=== tests/CMakeLists.txt ===
######################################################
# TESTS

include_directories(include)

set(BT_TESTS
  src/action_test_node.cpp
  src/condition_test_node.cpp
  gtest_tree.cpp
  gtest_sequence.cpp
  gtest_parallel.cpp
  gtest_fallback.cpp
  gtest_factory.cpp
  gtest_decorator.cpp
  gtest_blackboard.cpp
  gtest_coroutines.cpp
  navigation_test.cpp
  gtest_subtree.cpp
)

if(ament_cmake_FOUND AND BUILD_TESTING)

    find_package(ament_cmake_gtest REQUIRED)

    ament_add_gtest_executable(${BEHAVIOR_TREE_LIBRARY}_test ${BT_TESTS})
    target_link_libraries(${BEHAVIOR_TREE_LIBRARY}_test ${BEHAVIOR_TREE_LIBRARY}
                                                        crossdoor_nodes dummy_nodes
                                                        ${ament_LIBRARIES})
    target_include_directories(${BEHAVIOR_TREE_LIBRARY}_test PRIVATE gtest/include)
    include_directories($<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty>)

elseif(catkin_FOUND AND CATKIN_ENABLE_TESTING)

    catkin_add_gtest(${BEHAVIOR_TREE_LIBRARY}_test ${BT_TESTS})
    target_link_libraries(${BEHAVIOR_TREE_LIBRARY}_test ${BEHAVIOR_TREE_LIBRARY}
                                                        crossdoor_nodes dummy_nodes
                                                        ${catkin_LIBRARIES})
    target_include_directories(${BEHAVIOR_TREE_LIBRARY}_test PRIVATE gtest/include)

elseif(GTEST_FOUND AND BUILD_UNIT_TESTS)

    enable_testing()

    add_executable(${BEHAVIOR_TREE_LIBRARY}_test ${BT_TESTS})
    target_link_libraries(${PROJECT_NAME}_test ${BEHAVIOR_TREE_LIBRARY}
                                                crossdoor_nodes dummy_nodes
                                                ${GTEST_LIBRARIES}
                                                ${GTEST_MAIN_LIBRARIES})
    target_include_directories(${BEHAVIOR_TREE_LIBRARY}_test PRIVATE gtest/include ${GTEST_INCLUDE_DIRS})

    add_test(BehaviorTreeCoreTest ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${BEHAVIOR_TREE_LIBRARY}_test)

endif()

=== tools/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)


add_executable(bt_log_cat         bt_log_cat.cpp )
target_link_libraries(bt_log_cat  ${BEHAVIOR_TREE_LIBRARY} )
install(TARGETS bt_log_cat
        DESTINATION ${BEHAVIOR_TREE_BIN_DESTINATION} )

if( ZMQ_FOUND )
    add_executable(bt_recorder         bt_recorder.cpp )
    target_link_libraries(bt_recorder  ${BEHAVIOR_TREE_LIBRARY} )
    install(TARGETS bt_recorder
            DESTINATION ${BEHAVIOR_TREE_BIN_DESTINATION} )
endif()

add_executable(bt_plugin_manifest         bt_plugin_manifest.cpp )
target_link_libraries(bt_plugin_manifest  ${BEHAVIOR_TREE_LIBRARY} )
install(TARGETS bt_plugin_manifest
        DESTINATION ${BEHAVIOR_TREE_BIN_DESTINATION} )

=== 3rdparty/backward-cpp/CMakeLists.txt ===
#
# CMakeLists.txt
# Copyright 2013 Google Inc. All Rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

cmake_minimum_required(VERSION 2.8.12)
project(backward CXX)

# Introduce variables:
# * CMAKE_INSTALL_LIBDIR
# * CMAKE_INSTALL_BINDIR
# * CMAKE_INSTALL_INCLUDEDIR
include(GNUInstallDirs)

include(BackwardConfig.cmake)

# check if compiler is nvcc or nvcc_wrapper
set(COMPILER_IS_NVCC false)
get_filename_component(COMPILER_NAME ${CMAKE_CXX_COMPILER} NAME)
if (COMPILER_NAME MATCHES "^nvcc")
  set(COMPILER_IS_NVCC true)
endif()

if (DEFINED ENV{OMPI_CXX} OR DEFINED ENV{MPICH_CXX})
   if ( ($ENV{OMPI_CXX} MATCHES "nvcc") OR ($ENV{MPICH_CXX} MATCHES "nvcc") )
     set(COMPILER_IS_NVCC true)
   endif()
endif()

# set CXX standard
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_STANDARD 11)
if (${COMPILER_IS_NVCC})
  # GNU CXX extensions are not supported by nvcc
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()

###############################################################################
# COMPILER FLAGS
###############################################################################

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_COMPILER_IS_GNUCXX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
	if (NOT ${COMPILER_IS_NVCC})
	  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic-errors")
	endif()
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
endif()

###############################################################################
# BACKWARD OBJECT
###############################################################################

add_library(backward_object OBJECT backward.cpp)
target_compile_definitions(backward_object PRIVATE ${BACKWARD_DEFINITIONS})
target_include_directories(backward_object PRIVATE ${BACKWARD_INCLUDE_DIRS})
set(BACKWARD_ENABLE $<TARGET_OBJECTS:backward_object> CACHE STRING
	"Link with this object to setup backward automatically")


###############################################################################
# BACKWARD LIBRARY (Includes backward.cpp)
###############################################################################
option(BACKWARD_SHARED "Build dynamic backward-cpp shared lib" OFF)

if(BACKWARD_SHARED)
    set(libtype SHARED)
endif()
add_library(backward ${libtype} backward.cpp)
target_compile_definitions(backward PUBLIC ${BACKWARD_DEFINITIONS})
target_include_directories(backward PUBLIC ${BACKWARD_INCLUDE_DIRS})

###############################################################################
# TESTS
###############################################################################

if(BACKWARD_TESTS)
	enable_testing()

	add_library(test_main SHARED test/_test_main.cpp)

	macro(backward_add_test src)
		get_filename_component(name ${src} NAME_WE)
		set(test_name "test_${name}")

		add_executable(${test_name} ${src} ${ARGN})

		target_link_libraries(${test_name} PRIVATE Backward::Backward test_main)

		add_test(NAME ${name} COMMAND ${test_name})
	endmacro()

	# Tests without backward.cpp
	set(TESTS
		test
		stacktrace
		rectrace
		select_signals
		)

	foreach(test ${TESTS})
		backward_add_test(test/${test}.cpp)
	endforeach()

	# Tests with backward.cpp
	set(TESTS
		suicide
		)

	foreach(test ${TESTS})
		backward_add_test(test/${test}.cpp ${BACKWARD_ENABLE})
	endforeach()
endif()

install(
    FILES "backward.hpp"
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)
install(
    FILES "BackwardConfig.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/backward
)

=== debian/changelog ===
ros-lunar-behaviortree-cpp-v3 (3.0.7-0xenial) xenial; urgency=high

  * this should fix issue with tinyXML2 once and for all (maybe...)
  * improvement #79
  * doc fix
  * Deprecating <remap> tag in SubTree
  * fix windows compilation
  * Update README.md
  * back to c++11
  * Contributors: Davide Faconti, Ferran Roure

 -- Davide Faconti <davide.faconti@gmail.com>  Mon, 01 Apr 2019 22:00:00 -0000

ros-lunar-behaviortree-cpp-v3 (3.0.4-0xenial) xenial; urgency=high

  * fix issue #72 with sibling subtrees
  * Update .travis.yml
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Mon, 18 Mar 2019 23:00:00 -0000

ros-lunar-behaviortree-cpp-v3 (3.0.3-0xenial) xenial; urgency=high

  * moving to C++14... deal with it
  * updated tinyXML2. Should fix several issues too
  * add "d" to debug library on Windows
  * fixed compilation error on Windows x64 (issue #63)
  * Improved MSVC compilation
    Added _CRT_SECURE_NO_WARNINGS flag for msvc compilation
  * adding TreeNode::modifyPortsRemapping that might be useful in the future
  * Merge pull request #64 from luminize/patch-1
    docs/xml_format.md
  * Merge pull request #65 from luminize/patch-2
    docs/tutorial_01_first_tree.md: fix typo
  * docs/tutorial_01_first_tree.md: fix typo
  * fix compilation in Windows/Release
  * remove a warning in Windows
  * Update README.md
  * Merge branch 'windows_compilation'
  * fix issue #63 : compile on windows
  * Update .travis.yml
  * Create .appveyor.yml
  * fix compilation on windows
  * fix potential issue
  * bug fix
  * Update README.md
  * Contributors: Bas de Bruijn,  Davide Faconti, Jimmy Delas, hlzl

 -- Davide Faconti <davide.faconti@gmail.com>  Mon, 11 Mar 2019 23:00:00 -0000

ros-lunar-behaviortree-cpp-v3 (3.0.2-0xenial) xenial; urgency=high

  * make flatbuffers visible to other project (such as Groot)
  * docs fix
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Sun, 03 Mar 2019 23:00:00 -0000

ros-lunar-behaviortree-cpp-v3 (3.0.0-0xenial) xenial; urgency=high

  * Merge branch 'ver_3'. Too many changes to count...
  * Contributors: Davide Facont, Davide Faconti, ImgBotApp, Victor Lopez

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 26 Feb 2019 23:00:00 -0000

ros-lunar-behaviortree-cpp-v3 (2.5.1-0xenial) xenial; urgency=high

  * fix installation directory
  * #39 Fix Conan version (#42)
    Signed-off-by: Uilian Ries <mailto:uilianries@gmail.com>
  * Update .travis.yml
  * Conan package distribution (#39)
  * Non-functional refactoring of xml_parsing to clean up the code
  * cosmetic changes in the code of BehaviorTreeFactory
  * XML schema. Related to enchancement #40
  * call setRegistrationName() for built-in Nodes
    The methos is called by BehaviorTreefactory, therefore it
    registrationName is empty if trees are created programmatically.
  * Reset reference count when destroying logger (issue #38)
  * Contributors: Davide Facont, Davide Faconti, Uilian Ries

 -- Davide Faconti <davide.faconti@gmail.com>  Sun, 13 Jan 2019 23:00:00 -0000

ros-lunar-behaviortree-cpp-v3 (2.5.0-0xenial) xenial; urgency=high

  * Introducing SyncActionNode that is more self explaining and less ambiguous
  * fix potential problem related to ControlNode::haltChildren()
  * Adding example/test of navigation and recovery behavior. Related to issue #36
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 11 Dec 2018 23:00:00 -0000

ros-lunar-behaviortree-cpp-v3 (2.4.4-0xenial) xenial; urgency=high

  * adding virtual TreeNode::onInit() [issue #33]
  * fix issue #34 : if you don't implement convertFromString, it will compile but it may throw
  * Pretty demangled names and obsolate comments removed
  * bug fixes
  * more comments
  * [enhancement #32]: add CoroActionNode and rename ActionNode as "AsynActionNode"
    The name ActionNode was confusing and it has been deprecated.
  * Update README.md
  * removed old file
  * Fix issue #31 : convertFromString mandatory for TreeNode::getParam, not Blackboard::get
  * Cherry piking changes from PR #19 which solve issue #2 CONAN support
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 11 Dec 2018 23:00:00 -0000

ros-lunar-behaviortree-cpp-v3 (2.4.3-0xenial) xenial; urgency=high

  * Merge branch 'master' into ros2
  * removed old file
  * Fix issue #31 : convertFromString mandatory for TreeNode::getParam, not Blackboard::get
  * 2.4.3
  * version bump
  * Merge pull request #30 from nuclearsandwich/patch-1
    Fix typo in package name.
  * Remove extra find_package(ament_cmake_gtest).
    This package should only be needed if BUILD_TESTING is on and is
    find_package'd below if ament_cmake is found and BUILD_TESTING is on.
  * Fix typo in package name.
  * added video to readme
  * Cherry piking changes from PR #19 which solve issue #2 CONAN support
  * Merge pull request #29 from nuclearsandwich/ament-gtest-dep
    Add test dependency on ament_cmake_gtest.
  * Add test dependency on ament_cmake_gtest.
  * fix travis removing CI
  * Contributors: Davide Faconti, Steven! Ragnarök

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 06 Dec 2018 23:00:00 -0000

ros-lunar-behaviortree-cpp-v3 (2.4.2-0xenial) xenial; urgency=high

  * support ament
  * change to ament
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 04 Dec 2018 23:00:00 -0000

ros-lunar-behaviortree-cpp-v3 (2.4.1-0xenial) xenial; urgency=high

  * fix warnings and dependencies in ROS, mainly related to ZMQ
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 04 Dec 2018 23:00:00 -0000

ros-lunar-behaviortree-cpp-v3 (2.4.0-0xenial) xenial; urgency=high

  * Merge pull request #27 from mjeronimo/bt-12-4-2018
    Add support for ament/colcon build
  * updated documentation
  * Merge pull request #25 from BehaviorTree/include_xml
    Add the ability to include an XML from another one


=== debian/control ===
Source: ros-lunar-behaviortree-cpp-v3
Section: misc
Priority: extra
Maintainer: Davide Faconti <davide.faconti@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libdw-dev, libzmq3-dev, ros-lunar-catkin, ros-lunar-roslib
Homepage: 
Standards-Version: 3.9.2

Package: ros-lunar-behaviortree-cpp-v3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdw-dev, libzmq3-dev, ros-lunar-roslib
Description: This package provides the Behavior Trees core library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/lunar" \
		-DCMAKE_PREFIX_PATH="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-behaviortree-cpp-v3//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
